#ifndef VDMAPEDITOR_H
#define VDMAPEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include "VDSprite.h"
#include "VDInput.h"
#include "VDNPC.h"
#include "VDError.h"
#include "Resource.h"



/* **********************************************************************************************************************
   VDMapEditor
   **********************************************************************************************************************/

class VDMapEditor {
public:
    VDMapEditor();
    ~VDMapEditor();

    void FreeMemory();
    HWND LoadMapEditor(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessMapEditor(LPDIRECT3DDEVICE9 direct3DDevice, VDInput *input, vector<VDNPC>* npcs, vector<VDEntity>* objects);
    void VDOpenFile(HWND window, LPSTR filter, LPSTR fileName);

    void Clear();

    LPRECT GetTileSheetDimensions(LPRECT outRect);
    LPRECT GetTileSheetSourceRectangle(LPRECT outRect);
      void SetSelectedTile(VDSprite *newSprite);
    LPRECT GetObjectSpriteDimensions(LPRECT outRect);
      void SetObjectSprite(VDSprite *newSprite);

         HWND GetWindow()                       { return window; }
         HWND GetTransparencyColor()            { return transparencyColor; }
    VDSprite* GetTileSheet()                    { return tileSheet; }
       LPCSTR GetTileSheetImageLocation()       { return tileSheetImageLocation; }
       LPCSTR GetSelectedTileImageLocation()                     { return selectedTileImageLocation; }
         void SetSelectedTileImageLocation(LPCSTR imageLocation) { (void) strcpy_s(selectedTileImageLocation, imageLocation); }
         HWND GetObjectListBox()                                 { return objectListBox; }
    VDSprite* GetObjectSprite()                 { return objectSprite; }
         HWND GetNullTileOption()               { return nullTileOption; }
         HWND GetOpenTileOption()               { return openTileOption; }
         HWND GetImpassableTileOption()         { return impassableTileOption; }
         HWND GetNewAreaTileOption()            { return newAreaTileOption; }
       LPCSTR GetNewAreaFileLocation()          { return newAreaFileLocation; }
         HWND GetNewAreaStartingPointX()        { return newAreaStartingPointX; }
         HWND GetNewAreaStartingPointY()        { return newAreaStartingPointY; }
       LPCSTR GetSelectedObjectImageLocation()  { return selectedObjectImageLocation; }
         HWND GetNullObjectOption()             { return nullObjectOption; }
         HWND GetNPCOption()                    { return npcOption; }
         HWND GetStaticObjectOption()           { return staticObjectOption; }
         BOOL IsTileSelected()                  { return tileSelected; }
         void SetTileSelected(BOOL isSelected)  { tileSelected = isSelected; }
          int GetSelectedRadioButton()          { return selectedRadioButton; }
private:
         HWND window;
         HWND transparencyColor;
         HWND loadSpriteButton;
    VDSprite* tileSheet;
         char tileSheetImageLocation[FILE_NAME_MAX_SIZE];
         RECT tileSheetDimensions;
         RECT tileSheetSourceRectangle;
    VDSprite* selectedTile;
         char selectedTileImageLocation[FILE_NAME_MAX_SIZE];
         HWND shiftTileSpriteUp;
         HWND shiftTileSpriteDown;
         HWND shiftTileSpriteLeft;
         HWND shiftTileSpriteRight;
         HWND tileSpawnsListBox;
         HWND creaturesListBox;
         HWND removeSpawnButton;
         HWND addSpawnButton;
         HWND nullTileOption;
         HWND openTileOption;
         HWND impassableTileOption;
         HWND newAreaTileOption;
         HWND loadNewAreaButton;
         HWND newAreaStatic;
         char newAreaFileLocation[FILE_NAME_MAX_SIZE];
         HWND newAreaStartingPointX;
         HWND newAreaStartingPointY;
         HWND objectListBox;
    VDSprite* objectSprite;
         char selectedObjectImageLocation[FILE_NAME_MAX_SIZE];
         char previousObjectSelection[FILE_NAME_MAX_SIZE];
         RECT objectSpriteDimensions;
         HWND previousAnimationButton;
         HWND nextAnimationButton;
         HWND nullObjectOption;
         HWND npcOption;
         HWND staticObjectOption;
         BOOL tileSelected;
          int selectedRadioButton;
};



#endif  // VDMAPEDITOR_H