#ifndef VDNPCEDITOR_H
#define VDNPCEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include "VDNPC.h"
#include "VDSprite.h"
#include "VDInput.h"
#include "VDError.h"
#include "Resource.h"
using namespace std;



/* **********************************************************************************************************************
   VDNPCEditor
   **********************************************************************************************************************/

class VDNPCEditor {
public:
    VDNPCEditor();
    ~VDNPCEditor();

    void FreeMemory();
    HWND LoadNPCEditor(HINSTANCE instance, HWND parentWindow, LPCSTR className);
    void ProcessNPCEditor(LPDIRECT3DDEVICE9 direct3DDevice, VDInput *input, vector<VDNPC>* npcs);
    BOOL AddNPC(vector<VDNPC>* npcs, LPCSTR previousName, LPCSTR name, LPCSTR imageFileLocation, int movementSpeed);
    void RemoveNPC(vector<VDNPC>* npcs, LPCSTR name);

    void AddNPCDialogue(vector<VDNPC>* npcs, LPCSTR npcName, int id, LPCSTR text);
    void RemoveNPCDialogue(vector<VDNPC>* npcs, LPCSTR name, int id);
    void AddNPCDialogueOption(vector<VDNPC>* npcs, LPCSTR name, int dialogueID, LPCSTR text, int nextID);
    void RemoveNPCDialogueOption(vector<VDNPC>* npcs, LPCSTR npcName, int dialogueID, LPCSTR optionName);

    void VDOpenFile(HWND window, LPSTR filter, LPSTR fileName);
    void WriteNPCs(vector<VDNPC>* npcs);
    void CreateNPCTexture(LPDIRECT3DDEVICE9 direct3DDevice, VDSprite* sprite, LPCSTR npcFileName);

       VDNPC* GetNPC(LPCSTR aName, vector<VDNPC>* npcs);
       LPRECT GetNPCSpriteDimensions(LPRECT outRect);
         HWND GetWindow()                { return window; }
         HWND GetNPCListBox()            { return npcListBox; }
    VDSprite* GetNPCSpriteSheet()        { return npcSpriteSheet; }
    VDSprite* GetNPCSprite()             { return npcSprite; }
         BOOL GetReloadNPCs()            { return reloadNPCs; }
         void SetReloadNPCs(BOOL reload) { reloadNPCs = reload; }
private:
         HWND window;
         HWND npcListBox;
         char npcEditorPreviousNPCSelection[FILE_NAME_MAX_SIZE];
         HWND nameEditBox;
         HWND loadSpriteButton;
    VDSprite* npcSpriteSheet;
         char npcSpriteSheetLocation[FILE_NAME_MAX_SIZE];
         RECT npcSpriteDimensions;
    VDSprite* npcSprite;
         char npcSpriteImageLocation[FILE_NAME_MAX_SIZE];
         HWND shiftNPCUp;
         HWND shiftNPCDown;
         HWND previousAnimation;
         HWND nextAnimation;
         HWND movementSpeedEditBox;
         HWND removeNPCButton;
         HWND newNPCButton;
         HWND saveNPCButton;
         HWND dialogueListBox;
         char npcEditorPreviousDialogueSelection[FILE_NAME_MAX_SIZE];
         HWND textEditBox;
         HWND textIDEditBox;
         HWND removeDialogueButton;
         HWND saveDialogueButton;
         HWND optionListBox;
         char npcEditorPreviousOptionSelection[FILE_NAME_MAX_SIZE];
         HWND textEditBox2;
         HWND textIDEditBox2;
         HWND removeOptionButton;
         HWND saveOptionButton;
         HWND saveChangesButton;
         BOOL reloadNPCs;
};



#endif  // VDNPCEDITOR_H