#ifndef VDWORLD_H
#define VDWORLD_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDTile.h"
#include "VDNPC.h"



/* **********************************************************************************************************************
   VDWorld
   **********************************************************************************************************************/

class VDWorld {
public:
    VDWorld();
    ~VDWorld();

    BOOL IsTileInBounds(int locationX, int locationY);
    BOOL IsTileVacant(int entityLocationX, int entityLocationY);
     int ReallocateWorld(int worldMouseLocationX, int worldMouseLocationY);
    void AddObject(BOOL isNPC, LPCSTR name, int locationX, int locationY, LPCSTR imageFileLocation, int movementSpeed, int facingDirection, DWORD colorKey);
    void RemoveObject(int locationX, int locationY);
     int RunNPCLogic(unsigned int index, double currentTime);
    void MoveNPC(unsigned int index, int direction);
    void ClearWorld();
    void WriteWorld(LPCSTR fileName);
    void LoadWorld(LPCSTR fileName);

    VDTile* GetTile(int x, int y) { return &world[x][y]; }
        int GetWorldSizeX();
        int GetWorldSizeY();
     size_t GetNPCsSize();
     LPCSTR GetNPCName(unsigned int index);
        int GetNPCCurrentLocationX(unsigned int index);
        int GetNPCCurrentLocationY(unsigned int index);
       void SetNPCCurrentLocation(unsigned int index, int x, int y);
        int GetNPCDirection(unsigned int index);
     LPCSTR GetNPCImageFileLocation(unsigned int index);
     LPCSTR GetNPCDialogue(unsigned int npcIndex, unsigned int dialogueIndex);
      DWORD GetObjectColorKey(unsigned int index);
private:
            VDTile** world;
                 int worldSizeX;
                 int worldSizeY;
       vector<VDNPC> npcs;
    vector<VDEntity> objects;
};



#endif